---
title: Rename or Move an Entry
description: The PUT /directory/v1/{{dn}} endpoint functions like an LDAP moddn operation for moving or renaming one LDAP entry when the _dn attribute is included in the request. To change the DN of an entry, both the new DN and the naming attribute, the attribute used in the entry's RDN (relative distinguished name), must be present in the specified entry, even if the naming attribute is not changing. This rename operation can be in the same request as other attributes are modified. However, an error from either the rename or the modify portions of the request causes the entire operation to fail.
component: pingdirectory
page_id: pingdirectory:directory:directory-entry-apis/rename-or-move-an-entry
canonical_url: https://developer.pingidentity.com/pingdirectory/directory/directory-entry-apis/rename-or-move-an-entry.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Rename or Move an Entry

##

```none
PUT {{apiPath}}/directory/v1/{{dn}}
```

The `PUT /directory/v1/{{dn}}` endpoint functions like an LDAP `moddn` operation for moving or renaming one LDAP entry when the `_dn` attribute is included in the request. To change the DN of an entry, both the new DN and the naming attribute, the attribute used in the entry's RDN (relative distinguished name), must be present in the specified entry, even if the naming attribute is not changing. This rename operation can be in the same request as other attributes are modified. However, an error from either the rename or the modify portions of the request causes the entire operation to fail.

|   |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| - | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | If an entry is renamed and modified in one request, a Multi-Update Request Extended Request (OID 1.3.6.1.4.1.30221.2.6.17) is used. The request can fail if no ACI is created to allow a user to use this request, even if the user has permission to perform modify and rename operations independently. The following sample shows a multi-update ACI:```none
(extop="1.3.6.1.4.1.30221.2.6.17")(version 3.0; acl "Grant access to the Multi Update Extended Request for the rest-api-client account"; allow (all) userdn="ldap:///uid=rest-api-client,o=example";)
``` |

You can use the `PUT /directory/v1/{{dn}}` operation to change the name associated with the specified entry from Linda Jones to Linda Smith.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "_dn": "uid=lindasmith,ou=people,dc=example,dc=com",
    "uid": [
        "lindasmith"
    ],
    "cn": [
        "Linda Smith"
    ],
    "sn": [
        "Smith"
    ]
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PUT '{{apiPath}}/directory/v1/{{dn}}' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "_dn": "uid=lindasmith,ou=people,dc=example,dc=com",
    "uid": [
        "lindasmith"
    ],
    "cn": [
        "Linda Smith"
    ],
    "sn": [
        "Smith"
    ]
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/directory/v1/{{dn}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""_dn"": ""uid=lindasmith,ou=people,dc=example,dc=com""," + "\n" +
@"    ""uid"": [" + "\n" +
@"        ""lindasmith""" + "\n" +
@"    ]," + "\n" +
@"    ""cn"": [" + "\n" +
@"        ""Linda Smith""" + "\n" +
@"    ]," + "\n" +
@"    ""sn"": [" + "\n" +
@"        ""Smith""" + "\n" +
@"    ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/directory/v1/{{dn}}"
  method := "PUT"

  payload := strings.NewReader(`{
    "_dn": "uid=lindasmith,ou=people,dc=example,dc=com",
    "uid": [
        "lindasmith"
    ],
    "cn": [
        "Linda Smith"
    ],
    "sn": [
        "Smith"
    ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PUT /directory/v1/{{dn}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "_dn": "uid=lindasmith,ou=people,dc=example,dc=com",
    "uid": [
        "lindasmith"
    ],
    "cn": [
        "Linda Smith"
    ],
    "sn": [
        "Smith"
    ]
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"_dn\": \"uid=lindasmith,ou=people,dc=example,dc=com\",\n    \"uid\": [\n        \"lindasmith\"\n    ],\n    \"cn\": [\n        \"Linda Smith\"\n    ],\n    \"sn\": [\n        \"Smith\"\n    ]\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/directory/v1/{{dn}}")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/directory/v1/{{dn}}",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "_dn": "uid=lindasmith,ou=people,dc=example,dc=com",
    "uid": [
      "lindasmith"
    ],
    "cn": [
      "Linda Smith"
    ],
    "sn": [
      "Smith"
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/directory/v1/{{dn}}',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "_dn": "uid=lindasmith,ou=people,dc=example,dc=com",
    "uid": [
      "lindasmith"
    ],
    "cn": [
      "Linda Smith"
    ],
    "sn": [
      "Smith"
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/directory/v1/{{dn}}"

payload = json.dumps({
  "_dn": "uid=lindasmith,ou=people,dc=example,dc=com",
  "uid": [
    "lindasmith"
  ],
  "cn": [
    "Linda Smith"
  ],
  "sn": [
    "Smith"
  ]
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/directory/v1/{{dn}}');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "_dn": "uid=lindasmith,ou=people,dc=example,dc=com",\n    "uid": [\n        "lindasmith"\n    ],\n    "cn": [\n        "Linda Smith"\n    ],\n    "sn": [\n        "Smith"\n    ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/directory/v1/{{dn}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "_dn": "uid=lindasmith,ou=people,dc=example,dc=com",
  "uid": [
    "lindasmith"
  ],
  "cn": [
    "Linda Smith"
  ],
  "sn": [
    "Smith"
  ]
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"_dn\": \"uid=lindasmith,ou=people,dc=example,dc=com\",\n    \"uid\": [\n        \"lindasmith\"\n    ],\n    \"cn\": [\n        \"Linda Smith\"\n    ],\n    \"sn\": [\n        \"Smith\"\n    ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/directory/v1/{{dn}}")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_dn": "uid=lindasmith,ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "person",
        "organizationalPerson",
        "inetOrgPerson"
    ],
    "uid": [
        "lindasmith"
    ],
    "cn": [
        "Linda Smith"
    ],
    "sn": [
        "Smith"
    ],
    "ubidEmailJSON": [
        {
            "type": "home",
            "value": "user@example.com",
            "verified": true
        }
    ],
    "_links": {
        "schemas": [
            {
                "href": "https://ds.example.com/directory/v1/schemas/inetOrgPerson"
            }
        ],
        "self": {
            "href": "https://ds.example.com/directory/v1/uid=lindasmith,ou=people,dc=example,dc=com"
        }
    }
}
```
